EDB = {};

EDBFrame = CreateFrame("Frame", "EDBFrame")
local function OnEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB:CreateFrame();
			EDB:UpdateLines("taurast");
			GuildRosterContainer:HookScript("OnUpdate", function() EDB:GuildFrameUpdated() end);
		end
	elseif(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
		if(prefix=="EDB") then
			print(msg);
			name=string.sub(msg,1,string.find(msg,":")-1);
			MS=string.sub(msg,string.find(msg,":")+1,string.find(msg,";")-1);
			OS=string.sub(msg,string.find(msg,";")+1,string.find(msg,"@")-1);
			updated=tonumber(string.sub(msg,string.find(msg,"@")+1, -1));
			print(name.." "..MS.." "..OS.." "..updated);
			if(ELGOHDB[name]) then
				if(ELGOHDB[name]["updated"]<updated) then
					ELGOHDB[name]["MS"]=MS;
					ELGOHDB[name]["OS"]=OS;
					ELGOHDB[name]["updated"]=time();
				end
			else
				ELGOHDB[name]={}
				ELGOHDB[name]["MS"]=MS;
				ELGOHDB[name]["OS"]=OS;
				ELGOHDB[name]["updated"]=time();
			end
		end
	end
end

function EDB:CreateFrame()
	if (GuildMemberDetailFrame) then
		EDBFrame:SetParent(GuildMemberDetailFrame);
		EDBFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
		EDBFrame:SetHeight(55);
		EDBFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "BOTTOMLEFT", 0, 5);
		EDBFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
		
		EDBMSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBMSText:SetHeight(10);
		EDBMSText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBOSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBOSText:SetHeight(10);
		EDBOSText:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		
		EDBButton=CreateFrame("Button",nil,EDBFrame,"UIMenuButtonStretchTemplate")
		EDBButton:RegisterForClicks("AnyUp");
		
		EDBButton:SetScript("OnShow", nil);
		EDBButton:SetScript("OnMouseDown", nil);
		EDBButton:SetScript("OnMouseUp", nil);
		
		EDBButton:SetScript("OnClick", EDB_EDIT);
		EDBButton:SetPoint("RIGHT", "EDBFrame", "RIGHT", -5,0);
		EDBButton:SetWidth(25)
		EDBButton:SetHeight(EDBFrame:GetHeight()-10)
		EDBButton:SetText("+");
	end
end

function EDB:GuildFrameUpdated()
	local pname = GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if pname == EDB.selected then return end
		EDB.selected = pname;
		EDB:UpdateLines(pname);
	end
end

function EDB:UpdateLines(who)
	if(ELGOHDB[who]) then
		EDBMSText:SetText("MS: "..ELGOHDB[who]["MS"]);
		EDBOSText:SetText("OS: "..ELGOHDB[who]["OS"]);
	else
		EDBMSText:SetText("No DB entry for "..who);
		EDBOSText:SetText(":(");
	end
end

EDBFrame:SetScript("OnEvent", OnEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");
RegisterAddonMessagePrefix("EDB");


function EDB_ADD(member,MS,OS)
	for i = 1, GetNumGuildMembers(0), 1 do 
		name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
		if(name==member) then
			ELGOHDB[member]={};
			ELGOHDB[member]["MS"]=MS;
			ELGOHDB[member]["OS"]=OS;
			ELGOHDB[member]["updated"]=time();
		end
	end
end

function EDB_SYNC()
	for i = 1, GetNumGuildMembers(), 1 do 
		name, rank, rankIndex, level, class = GetGuildRosterInfo(i);
		if(ELGOHDB[name]) then
			SendAddonMessage("EDB", name..":"..ELGOHDB[name]["MS"]..";"..ELGOHDB[name]["OS"].."@"..ELGOHDB[name]["updated"], "GUILD");
		end
	end
end

function EDB_EDIT(member)
name=GetGuildRosterInfo(GetGuildRosterSelection());
	print(name);
end

